package PProxy;

use warnings;
use strict;

use Digest::MD5 qw( md5_hex );

use POWER::LOG;
our $LOG = $POWER::LOG::DEFAULT;


sub get_cache_ID {
    my ($s) = @_;
    my ($url)   = $s =~ /^((?:GET|POST) [^ ]+) HTTP\/1\.[01]\s*\n/i;
    my ($host)  = $s =~ /^Host: (\S+)\s*$/mi;
    my ($post)  = $s =~ /\r?\n\r?\n(.*)/s;
    my ($cookie)= join '; ', $s =~ /^Cookie: (.*)/mgi;   # Cookie2:  ???
    my ($range) = $s =~ /^Range: (\S+)\s*$/mi;
    $LOG->WARN('get_cache_ID: no url'), return 'nourl' unless defined $url;
    defined($_) or $_=q{} for $host, $post, $cookie, $range;
    $url =~ s! /! http://$host/!; #    =   
    $url =~ s/\?(.*)/'?'.norm_param($1,'&')/e;
    $post = norm_param($post,'&');
    #Opera  : +  %21%22%23%24%25%26%27%28%29%2A%2B%2C-  .  %2F0123456789%3A%3B%3C%3D%3E%3F%40ABCDEFGHIJKLMNOPQRSTUVWXYZ%5B%5C%5D%5E_%60abcdefghijklmnopqrstuvwxyz%7B%7C%7D%7E
    #Lynx   : +  %21%22%23%24%25%26%27%28%29*  %2B%2C-  .  %2F0123456789%3A%3B%3C%3D%3E%3F@  ABCDEFGHIJKLMNOPQRSTUVWXYZ%5B%5C%5D%5E_%60abcdefghijklmnopqrstuvwxyz%7B%7C%7D%7E
    #IE6    : +  %21%22%23%24%25%26%27%28%29*  %2B%2C-  .  %2F0123456789%3A%3B%3C%3D%3E%3F@  ABCDEFGHIJKLMNOPQRSTUVWXYZ%5B%5C%5D%5E_%60abcdefghijklmnopqrstuvwxyz%7B%7C%7D%7E
    #EncUri : %20%21%22%23%24%25%26%27%28%29%2A%2B%2C%2D%2E%2F0123456789%3A%3B%3C%3D%3E%3F%40ABCDEFGHIJKLMNOPQRSTUVWXYZ%5B%5C%5D%5E_%60abcdefghijklmnopqrstuvwxyz%7B%7C%7D%7E
    s/%20/+/gi, s/%2A/*/gi, s/%2D/-/gi, s/%2E/./gi, s/%40/@/gi for $post;
    $cookie = norm_param($cookie,'; ');
    # FIXME   cookies    .js , .. cookies
    #        
    $cookie = q{} if $url =~ /\.js$/;
    my $ID = "URL=$url\nHOST=$host\nCOOKIE=$cookie\nPOST=$post\nRANGE=$range\n";
    $LOG->DEBUG("\n".join(q{}, map {"\t$_\n"} split /\n/, $ID));
    return md5_hex($ID);
}

sub norm_param {
    my ($params, $div) = @_;
    $params =~ s/[\r\n]*$//;
    $LOG->WARN("bad params") if $params =~ /\n/;
    return join $div, sort split /$div/, $params;
}


1;
